ReportPreview        PROCEDURE(PrintPreviewQueue)

PageNumber      SHORT,AUTO
PageMarked      LONG(0)
LocalResponse   LONG
ZoomPercent     DECIMAL(3,2)
WidthPercent    DECIMAL(3,2)
HeightPercent   DECIMAL(3,2)
FullPagePercent DECIMAL(3,2)
ZoomSize        DECIMAL(3,2,.25)
ZoomMax         DECIMAL(3,2,2)
ZoomMinInit     DECIMAL(3,2,.50)
ImageWidth      LONG
ImageHeight     LONG
SaveFileName    String(100)
Option1         BYTE
PageFrom        LONG(1)
PageTo          LONG(1)

PreviewWindow WINDOW,AT(2,0,329,227),HVSCROLL,MAX,MAXIMIZE,MDI
       TOOLBAR,AT(0,0,329,18),NOMERGE
         BUTTON('&Full'),AT(20,2,18,13),TIP('Full Page View'),USE(?Full)
         BUTTON('+'),AT(38,2,13,13),FONT(,,,FONT:bold),TIP('Zoom In'),KEY(PlusKey),USE(?Plus)
         BUTTON('-'),AT(52,2,13,13),FONT(,,,FONT:bold),TIP('Zoom Out'),KEY(MinusKey),USE(?Minus)
         BUTTON,AT(131,2,13,13),TIP('Next Page'),KEY(PgDnKey),USE(?NextPage),ICON(icon:vcrfastforward)
         BUTTON,AT(1,1,17,16),TIP('Exit Without Printing'),KEY(EscKey),USE(?Cancel),ICON(icon:hand)
         BUTTON,AT(268,1,17,16),TIP('Print'),KEY(CtrlP),USE(?Print),ICON(ICON:Print)
         BUTTON,AT(250,1,17,16),TIP('Save as Metafile'),USE(?Save),ICON(ICON:Save)
         BUTTON,AT(145,2,13,13),TIP('Last Page'),KEY(EndKey),USE(?Bottom),ICON(ICON:VCRbottom)
         BUTTON('&GoTo'),AT(202,2,20,13),TIP('Go To Page..'),USE(?Goto)
         BUTTON('&Mark'),AT(223,2,26,13),TIP('Mark or UnMark Page'),USE(?Mark)
         BUTTON,AT(103,2,13,13),TIP('First Page'),KEY(HomeKey),USE(?Top),ICON(ICON:VCRtop)
         BUTTON,AT(117,2,13,13),TIP('Previous Page'),KEY(PgUpKey),USE(?PrevPage),ICON(ICON:VCRrewind)
         STRING('Zoom: .0 '),AT(68,4),FONT('Arial',8,,FONT:bold),USE(?ZoomPercentStr)
         STRING('Page 0 of 0'),AT(160,4),FONT('Arial',8,,FONT:bold),USE(?PageStr)
       END
       BOX,AT(0,0,50,50),USE(?Border),COLOR(00H)
       IMAGE,AT(1,1),USE(?ZoomedImage),SCROLL
     END

JumpWindow WINDOW,AT(,,89,32),FONT('System',8,,FONT:bold),CENTER,GRAY
       PROMPT('Go to Page'),AT(7,4)
       SPIN(@n5),AT(47,4,32,10),USE(PageNumber),RANGE(1,100),STEP(1)
       BUTTON('OK'),AT(28,18,32,10),USE(?OKButton),DEFAULT
     END

PrintWindow WINDOW('Print...'),AT(,,175,73),FONT('System',8,,FONT:bold),CENTER,SYSTEM,GRAY
       OPTION('Print Range'),AT(2,2,123,66),USE(Option1),BOXED
         RADIO('All Pages'),AT(7,12)
         RADIO('Marked Pages Only'),AT(7,22),USE(?Option1:Marked),DISABLE
         RADIO('Unmarked Pages Only'),AT(7,32),USE(?Option1:UnMarked),DISABLE
         RADIO('Range of Pages'),AT(7,42)
       END
       STRING('From:'),AT(20,54)
       ENTRY(@n5),AT(40,54,23,10),USE(PageFrom),LEFT,REQ,INS
       STRING('To:'),AT(70,54)
       ENTRY(@n5),AT(82,54,23,10),USE(PageTo),LEFT,REQ,INS
       BUTTON('OK'),AT(135,6,32,10),USE(?PrintOK),DEFAULT
       BUTTON('Cancel'),AT(135,20,32,10),USE(?PrintCancel)
     END

PREV:MetaFileName       string(100),Static
PREV:Metafile   FILE,DRIVER('dos'),NAME(PREV:MetaFileName)
Record            RECORD,PRE()
                  END
                END

MarkQueue       QUEUE,PRE(MQ)
Mark              BYTE
                END

   CODE
   LocalResponse = RequestCancelled
   #EMBED(%ReportPreviewSetup,'ReportPreview: Setup Procedure')
   DO Init
   ACCEPT
     CASE ACCEPTED()
       OF ?Print
         DO PrintReport
         IF LocalResponse = RequestCompleted
           POST(EVENT:CloseWindow)
         .
       OF ?Cancel
         POST(EVENT:CloseWindow)
       OF ?Save
         IF FILEDIALOG('Save Current Page to MetaFile...', |
                       SaveFileName, |
                       'Windows MetaFile|*.WMF', |
                       1)
           PREV:MetaFileName = PrintPreviewQueue
           COPY(PREV:MetaFile,SaveFileName)
         .
       OF ?Mark
         DO MarkPage
       OF ?Top
         PageNumber = 1
         DO DisplayPage
       OF ?Bottom
         PageNumber = RECORDS(PrintPreviewQueue)
         DO DisplayPage
       OF ?NextPage
         IF PageNumber < RECORDS(PrintPreviewQueue)
           PageNumber += 1
           DO DisplayPage
         .
       OF ?PrevPage
         IF PageNumber > 1
           PageNumber -= 1
           DO DisplayPage
         .
       OF ?Full
         ZoomPercent = FullPagePercent
         DO DisplayImage
       OF ?Plus
         IF ZoomPercent < ZoomMax
           ZoomPercent += ZoomSize
           IF ZoomPercent > ZoomMax; ZoomPercent = ZoomMax.
           DO DisplayImage
         .
       OF ?Minus
         IF ZoomPercent > ZoomSize
           ZoomPercent -= ZoomSize
           IF ZoomPercent < ZoomSize; ZoomPercent = ZoomSize.
           DO DisplayImage
         .
       OF ?GoTo
         OPEN(JumpWindow)
         PageNumber{Prop:RangeHigh} = RECORDS(PrintPreviewQueue)
         ACCEPT
           CASE ACCEPTED()
             OF ?OKButton
               POST(Event:CloseWindow)
         . .
         CLOSE(JumpWindow)
         DO DisplayPage
     END !Case Accepted()
   END !Accept Loop
   FREE(MarkQueue)
   GlobalResponse = LocalResponse
   RETURN

Init            ROUTINE
  OPEN(PreviewWindow)
  PageNumber = 1
  DO DisplayPage
  ?ZoomedImage{PROP:Text} = PrintPreviewQueue
  ImageWidth = ?ZoomedImage{Prop:Width} + 10
  ImageHeight = ?ZoomedImage{Prop:Height} + 10
  WidthPercent = TARGET{Prop:Width} / ImageWidth
  WidthPercent = INT(WidthPercent / ZoomSize) * ZoomSize
  HeightPercent = (TARGET{Prop:Height}-18) / ImageHeight
  HeightPercent = INT(HeightPercent / ZoomSize) * ZoomSize
  IF WidthPercent < HeightPercent
    ZoomPercent = WidthPercent
  ELSE
    ZoomPercent = HeightPercent
  .
  FullPagePercent = ZoomPercent
  IF ZoomPercent < ZoomMinInit; ZoomPercent = ZoomMinInit.
  DO DisplayImage
  MQ:Mark = 0
  LOOP Records(PrintPreviewQueue) Times
    ADD(MarkQueue)
  .

DisplayImage    ROUTINE
  ?Border{Prop:Width} = (ImageWidth+10) * ZoomPercent
  ?Border{Prop:Height} = (ImageHeight+10) * ZoomPercent
  ?ZoomedImage{Prop:Width} = ImageWidth * ZoomPercent
  ?ZoomedImage{Prop:Height} = ImageHeight * ZoomPercent
  ?ZoomPercentStr{Prop:Text} = 'Zoom: '&FORMAT(ZoomPercent*100,@N3)&' <37>'

DisplayPage     ROUTINE
  IF PageNumber = 1
    ?PrevPage{Prop:Disable}=True
    ?Top{Prop:Disable}=True
  ELSE
    ?PrevPage{Prop:Disable}=False
    ?Top{Prop:Disable}=False
  .
  GET(PrintPreviewQueue,PageNumber)
  ?ZoomedImage{Prop:Text} = PrintPreviewQueue
  IF PageNumber = RECORDS(PrintPreviewQueue)
    ?NextPage{Prop:Disable}=True
    ?Bottom{Prop:Disable}=True
  ELSE
    ?NextPage{Prop:Disable}=False
    ?Bottom{Prop:Disable}=False
  .
  ?PageStr{prop:text} = 'Page '&PageNumber&' of '&Records(PrintPreviewQueue)
  GET(MarkQueue,POINTER(PrintPreviewQueue))
  IF MQ:Mark
    ?Mark{Prop:Text} = 'Un&Mark'
  ELSE
    ?Mark{Prop:Text} = '&Mark'
  .

MarkPage        ROUTINE
  IF MQ:Mark
    PageMarked -= 1
    MQ:Mark = False
    ?Mark{Prop:Text} = '&Mark'
  ELSE
    PageMarked += 1
    MQ:Mark = True
    ?Mark{Prop:Text} = 'Un&Mark'
  .
  PUT(MarkQueue)

PrintReport     ROUTINE
  Option1 = 1
  OPEN(PrintWindow)
  IF PageMarked
    ?Option1:Marked{Prop:Disable} = False
    ?Option1:UnMarked{Prop:Disable} = False
  .
  ACCEPT
    CASE ACCEPTED()
      OF ?PrintOK
        LocalResponse = RequestCompleted
        POST(Event:CloseWindow)
      OF ?PrintCancel
        POST(Event:CloseWindow)
    END !Case Accepted()
    CASE SELECTED()
      OF PageFrom OROF PageTo
        Option1 = 4
    END !Case Selected()
  END !Accept Loop
  IF LocalResponse = RequestCompleted AND Option1 <> 1
    DO DiscardPages
  .
  CLOSE(PrintWindow)

DiscardPages        ROUTINE
  LOOP IDiscard# = RECORDS(PrintPreviewQueue) TO 1 BY -1
    IF Option1 = 2 OR Option1 = 3
      GET(MarkQueue,IDiscard#)
      IF(Option1 = 2 AND MQ:Mark) |
      OR(Option1 = 3 AND NOT MQ:Mark)
        CYCLE
      .
    ELSE
      IF IDiscard# >= PageFrom AND IDiscard# <= PageTo
        CYCLE
    . .
    GET(PrintPreviewQueue,IDiscard#)
    PREV:MetaFileName = PrintPreviewQueue
    REMOVE(PREV:MetaFile)
    DELETE(PrintPreviewQueue)
  END !Loop
